#include "includes.h"

BITS_DESCRIPTION  bits[BITS_MAXIMUM];

#define STB_ACT_SIGNAL_INDEX      0x03
#define SIGNAL_RADIO_TUNE_STEP    0x02
#define SIGNAL_AP_SYNC            0x3A

#define SIGNAL_AP_SET_A          0x38
#define SIGNAL_AP_SET_B          0x39

#define SIGNAL_RADIO_TUNE_A       0x00
#define SIGNAL_RADIO_TUNE_B       0x01


const char step_of_mode_table[] =
    {
    /* MODE_COM1 */      2,
    /* MODE_COM2 */      2,
    /* MODE_NAV1 */      2,
    /* MODE_NAV2 */      2,
    /* MODE_ADF */       3,
    /* MODE_DME */       2,
    /* MODE TXPND */     4,
    /* MODE_NAV_CRS */   2
    };

const char mask_of_mode_table[] =
    {
    /* MODE_COM1 */      0x0C,
    /* MODE_COM2 */      0x0C,
    /* MODE_NAV1 */      0x0C,
    /* MODE_NAV2 */      0x0C,
    /* MODE_ADF */       0x0E,
    /* MODE_DME */       0x0E,
    /* MODE TXPND */     0x0C,
    /* MODE_NAV_CRS */   0x0E
    };





char radio_step = 0;
char radio_mode = 0;
char ap_mode = 0;
char radio_stb_act = 0;


void discrete_task( void *pvParameters )
{
int bit_state;
int i;
unsigned short tmpu16;

char radio_mode_tmp = 0;
char ap_mode_tmp = 0;
 bits_init();

 while(1)
 {
  vTaskDelay(1);
  #if 1
     check_movements();
  #endif
  get_inputs64();
  for(i=0;i<BITS_MAXIMUM;i++)
  {
        if(i>=0x28 && i <=0x2F)
        {
           if(bits[i].signal)
                       ap_mode_tmp = i-0x28;
        }

        if(i>=0x18 && i <=0x1F)
        {
           if(bits[i].signal)
                       radio_mode_tmp = i-0x18;
        }

          bit_state = get_inputs64_bit(i);

           if(bit_state)
           {
               if(bits[i].counter < bits[i].max)
               {
                   if(++(bits[i].counter) >= bits[i].max)
                   {
                       if(bits[i].signal == 0)
                       {

                           //front __0__/--1--

                           if(bits[i].mode == ENCODER_A)
                           {
                               if(i == SIGNAL_RADIO_TUNE_A)
                               {
                                 tmpu16 = 0;
                                 tmpu16 |= (radio_step << 2);
                                 tmpu16 |= (radio_stb_act << 1);
                                 tmpu16 &= mask_of_mode_table[radio_mode];
                                 tmpu16 |= (radio_mode << 4);
                                 tmpu16 |= bits[i+1].signal;
                                 tmpu16 += 0x280;

                                 xQueueSend(com_queue,&tmpu16,0);

                               } else
                               if(i == SIGNAL_AP_SET_A)
                               {
                                 tmpu16 = 0x240;
                                 tmpu16 += (ap_mode << 1);
                                 tmpu16 += bits[i+1].signal;
                                 xQueueSend(com_queue,&tmpu16,0);
                               }
                           }
                           else if(bits[i].mode == ROTARY_SWITCH_POLE)
                           {
                                if(i>=0x18 && i <=0x1F)
                                {
                                    radio_step = 0;
                                    radio_stb_act = 0;
                                }

                           }
                            else if(bits[i].mode != ENCODER_B)
                           {

                                switch(i)
                                {
                                  case SIGNAL_RADIO_TUNE_STEP:
                                        radio_step++;
                                        if(radio_step >= step_of_mode_table[radio_mode])
                                            radio_step  = 0;
                                        tmpu16 = 0x860;
                                        tmpu16 += radio_mode;
                                        xQueueSend(com_queue,&tmpu16,0);
                                  break;


                                  case STB_ACT_SIGNAL_INDEX:
                                    radio_stb_act ^= 1;
                                    tmpu16 = 0x850;
                                    tmpu16 += radio_mode;
                                    xQueueSend(com_queue,&tmpu16,0);
                                  break;

                                  case SIGNAL_AP_SYNC:
                                    tmpu16 = 0x870;
                                    tmpu16 += ap_mode;
                                    xQueueSend(com_queue,&tmpu16,0);
                                  break;

                                 default:
                                    tmpu16 = 0x800 + i;
                                    xQueueSend(com_queue,&tmpu16,0);


                                }

                           }
                        }
                        bits[i].signal = 1;
                    }
                }
            }
            else
            {
                if(bits[i].counter > 0)
                {
                    if(--(bits[i].counter) <= 0)
                    {
                        if(bits[i].signal)
                        {
                            // edge  --1--\___0___
                            if( bits[i].mode == TOGGLE_SWITCH ||
                                bits[i].mode == PUSH_BUTTON )
                            {
                                switch(i)
                                {
                                  case SIGNAL_RADIO_TUNE_STEP:
                                        //radio_step++;
                                        //if(radio_step >= step_of_mode_table[radio_mode])
                                        //    radio_step  = 0;
                                        tmpu16 = 0x460;
                                        tmpu16 += radio_mode;
                                        xQueueSend(com_queue,&tmpu16,0);
                                  break;


                                  case STB_ACT_SIGNAL_INDEX:
                                    //radio_stb_act ^= 1;
                                    tmpu16 = 0x450;
                                    tmpu16 += radio_mode;
                                    xQueueSend(com_queue,&tmpu16,0);
                                  break;

                                  case SIGNAL_AP_SYNC:
                                    tmpu16 = 0x470;
                                    tmpu16 += ap_mode;
                                    xQueueSend(com_queue,&tmpu16,0);
                                  break;

                                 default:
                                    tmpu16 = 0x400 + i;
                                    xQueueSend(com_queue,&tmpu16,0);

                                }

                            }
                        }
                        bits[i].signal = 0;
                    }
                }
            }
        }
    radio_mode = radio_mode_tmp;
    ap_mode = ap_mode_tmp;
  }
}



void bits_init(void)
{
int i;
for(i=0;i<64;i++)
{
  input_init(i,NULL,TOGGLE_SWITCH);
}


  input_init_fast(0,NULL,ENCODER_A);
  input_init_fast(1,NULL,ENCODER_B);

  input_init_fast(56,NULL,ENCODER_A);
  input_init_fast(57,NULL,ENCODER_B);

  for(i=24;i<32;i++)
  {
    input_init(i,NULL,ROTARY_SWITCH_POLE);
  }

  for(i=40;i<48;i++)
  {
    input_init(i,NULL,ROTARY_SWITCH_POLE);
  }

}




void vApplicationTickHook( void )
{

}


void lcd_backlight_on(void)
{
  LPC_GPIO2->DATA |= (0x1<<3);
}

void lcd_backlight_off(void)
{
  LPC_GPIO2->DATA &= ~(0x1<<3);
}



