#ifndef __DISCRETE_IO_H__
#define __DISCRETE_IO_H__


enum {
   TOGGLE_SWITCH_0 = 0,
   TOGGLE_SWITCH_1,
   ITEMS_MAX
};

enum {
    MODE_COM1 = 0,
    MODE_COM2,
    MODE_NAV1,
    MODE_NAV2,
    MODE_ADF,
    MODE_DME,
    MODE_TXPND,
    MODE_NAV_CRS
 };

enum {
    AP_ALT = 0,
    AP_IAS,
    AP_VS,
    AP_HDG,
    AP_CRS,
    AP_BANK,
    AP_SPARE
 };


extern char radio_step;
extern char radio_mode;
extern char ap_mode;
extern char radio_stb_act;


#define BITS_MAXIMUM   64 /*ITEMS_MAX*/
typedef int (*FPVOID)(void *param);

typedef struct {
short counter;
short  max;
char signal;
//char flag;
//char evcode;
char mode;
//int pin;
} BITS_DESCRIPTION;


#define FLAG_INVERTED   (1<<0)
#define FLAG_ENABLED    (1<<1)


enum {
  PUSH_BUTTON = 0,
  TOGGLE_SWITCH,
  ROTARY_SWITCH_POLE,
  ENCODER_A,
  ENCODER_B
};


#define input_init(x,y,m)   do {\
bits[x].counter = 0;\
bits[x].signal = 0;\
bits[x].max = 50;\
bits[x].mode = m;\
} while(0)


#define input_init_fast(x,y,m)   do {\
bits[x].counter = 0;\
bits[x].signal = 0;\
bits[x].max = 5;\
bits[x].mode = m;\
} while(0)


void bits_init(void);
void discrete_task( void *pvParameters );

void led_control(int led, int state);
void leds_init(void);
void parser(char ch);
void lcd_backlight_off(void);
void lcd_backlight_on(void);
#endif




