#include "includes.h"
#define small_delay()   dly++;

const unsigned char correcting_table[64] = 
{
/*   1       2       3       4       5       6       7      8    */
  1*0x00, 1*0x01, 1*0x02, 1*0x03, 1*0x04, 1*0x07, 1*0x05, 1*0x06,

  8+0x02, 8+0x00, 8+0x03, 8+0x01, 8+0x05, 8+0x04, 8+0x07, 8+0x06,

  16+0x00, 16+0x01, 16+0x02, 16+0x03, 16+0x04, 16+0x05, 16+0x07, 16+0x06,

  24+0x01, 24+0x00, 24+0x03, 24+0x02, 24+0x05, 24+0x04, 24+0x07, 24+0x06,

  32+0x00, 32+0x01, 32+0x02, 32+0x03, 32+0x04, 32+0x05, 32+0x06, 32+0x07,

  40+0x01, 40+0x00, 40+0x03, 40+0x02, 40+0x05, 40+0x04, 40+0x07, 40+0x06,

  48+0x01, 48+0x00, 48+0x03, 48+0x02, 48+0x05, 48+0x04, 48+0x07, 48+0x06,

  56+0x04, 56+0x00, 56+0x01, 56+0x02, 56+0x03, 56+0x05, 56+0x06, 56+0x07
  
};


static long long cur_inputs = 0;


void inputs64_init(void)
{
  INPUTS_INIT();  
}  

long long get_inputs64(void)
{
volatile int dly;
long long acc;

int i,si_bit;

  LOAD_HIGH();
     small_delay();
    SCK_HIGH();
     small_delay();
    SCK_LOW();
     small_delay();
  LOAD_LOW();
    small_delay();
  for(i=0;i<64;i++)
  {
    si_bit=READ_PIN_SI();
    acc <<= 1;   
    acc |= (si_bit>>9);
    
    SCK_HIGH(); 
    small_delay();
    SCK_LOW();  
    small_delay();
    
  }
  cur_inputs = acc;
return acc;
}

int get_inputs64_bit(int bit)
{
bit = correcting_table[bit];
int result = ((cur_inputs >> bit)& 0x01)^1;
return result;  
}





