#include "includes.h"
void write_cgram_1(char const * ch);
void write_cgram_2(char const * ch);


const char user_symbol[8]=      {0x01,0x01,0x01,0x1E,0x01,0x01,0x01,0x00};

void wait_1us(int dly)
{
volatile long dly100;
  for(;dly;dly--)
    for(dly100 = 6; dly100; dly100--);
}

void EN_pulse_1(void)
{
	wait_1us(2);
        SET_E_1();
        wait_1us(2);
        CLR_E_1();
        wait_1us(2);
}

void EN_pulse_2(void)
{
	wait_1us(2);
        SET_E_2();
        wait_1us(2);
        CLR_E_2();
        wait_1us(2);
}



void write_byte_1(unsigned char b, unsigned char data_cmd)
{
  SET_RW_1();
   CLR_RS_1();
    wait_1us(2);
     SET_E_1();
      WAIT_0x80();
       CLR_E_1();
        wait_1us(2);
	 CLR_RW_1();
          CLR_RS_1();

        if (data_cmd)
        {
          SET_RS_1();
        }

          SET_DATA_HIGH(b);
	 wait_1us(2);
        EN_pulse_1();
       SET_DATA_LOW(b);
      wait_1us(2);
     EN_pulse_1();
}

void write_byte_2(unsigned char b, unsigned char data_cmd)
{
  SET_RW_2();
   CLR_RS_2();
    wait_1us(2);
     SET_E_2();
      WAIT_0x80();
       CLR_E_2();
        wait_1us(2);
	 CLR_RW_2();
          CLR_RS_2();

        if (data_cmd)
        {
          SET_RS_2();
        }

          SET_DATA_HIGH(b);
	 wait_1us(2);
        EN_pulse_2();
       SET_DATA_LOW(b);
      wait_1us(2);
     EN_pulse_2();
}



void write_cmd_1(unsigned char b)
{
  write_byte_1(b,0);
}

void write_cmd_2(unsigned char b)
{
  write_byte_2(b,0);
}

void write_data_1(unsigned char b)
{
  write_byte_1(b,1);
}

void write_data_2(unsigned char b)
{
  write_byte_2(b,1);
}


void lcd_init_1(void) {

        //LPC_GPIO2->DIR |= 0x7F0;
        //LPC_GPIO2->DATA = 0x030;
        wait_1us(50);
        EN_pulse_1();
        wait_1us(50);	  //  
            EN_pulse_1();
            wait_1us(50);	  //  
            EN_pulse_1();
           wait_1us(50);	  //  
        SET_DATA_HIGH(0x20);	  //   (4 )
        EN_pulse_1();
        wait_1us(50);	  //  


//               
	write_cmd_1(0x28);   //   
	write_cmd_1(0x0C);   // ,  
	write_cmd_1(0x01);   // 
	write_cmd_1(0x06);   //   :   
        write_cgram_1(user_symbol);

}

void lcd_init_2(void)
{

        //LPC_GPIO2->DIR |= 0x7F0;
        //LPC_GPIO2->DATA = 0x030;
        wait_1us(50);
        EN_pulse_2();
        wait_1us(50);	  //  
            EN_pulse_2();
            wait_1us(50);	  //  
            EN_pulse_2();
           wait_1us(50);	  //  
        SET_DATA_HIGH(0x20);	  //   (4 )
        EN_pulse_2();
        wait_1us(50);	  //  


//               
	write_cmd_2(0x28);   //   
	write_cmd_2(0x0C);   // ,  
	write_cmd_2(0x01);   // 
	write_cmd_2(0x06);   //   :   
        write_cgram_2(user_symbol);

}


void write_cgram_1(char const * ch)
{
int i;
      write_cmd_1(0x40);		//Set CGRAM address
      for(i=0;i<8;i++)
      {
        write_data_1(ch[i]);
      }
}

void write_cgram_2(char const * ch)
{
int i;
        write_cmd_2(0x40);		//Set CGRAM address
	for(i=0;i<8;i++)
        {
           write_data_2(ch[i]);
        }
}

void lcd_test_pins_1(void)
{
int i;

  while(1)
  {
    i += 16;

// RW 1
// RS 3
// EN 2
    SET_DATA_HIGH  ( i  );
    SET_RW_1();
    SET_E_1();
    SET_RS_1();
    vTaskDelay(1);
    CLR_RW_1();
    CLR_E_1();
    CLR_RS_1();
    vTaskDelay(1);
    SET_E_1();
    SET_RS_1();
    vTaskDelay(1);
    CLR_E_1();
    CLR_RS_1();
    vTaskDelay(1);
    SET_RS_1();
    vTaskDelay(1);
    CLR_RS_1();
    vTaskDelay(5);
  }
}

void lcd_test_pins_2(void)
{
int i;

  while(1)
  {
    i += 16;
// RW 1
// RS 3
// EN 2
    SET_DATA_HIGH(i);
    SET_RW_2();
    SET_E_2();
    SET_RS_2();
    vTaskDelay(1);
    CLR_RW_2();
    CLR_E_2();
    CLR_RS_2();
    vTaskDelay(1);
    SET_E_2();
    SET_RS_2();
    vTaskDelay(1);
    CLR_E_2();
    CLR_RS_2();
    vTaskDelay(1);
    SET_RS_2();
    vTaskDelay(1);
    CLR_RS_2();
    vTaskDelay(5);
  }
}




void lcd_puts(int lcd, int line, char const * text)
{
int i;

int cmd = 0x80;
if(line==1)
    cmd += 0x40;

void (*write_cmd)(unsigned char bt) = write_cmd_1;
void (*write_data)(unsigned char bt) = write_data_1;

    if(lcd==1)
    {
       write_cmd = write_cmd_2;
       write_data = write_data_2;
    }





        write_cmd(cmd);	//      
	for(i=0;i<16;i++)
        {
          if(!text[i])
                    break;
             write_data(text[i]);
        }

	for(;i<16;i++)
        {
          write_data(' ');
        }
}

