#ifndef __LCD_H__
#define __LCD_H__

#define INIT_LCD_PINS()  do {\
LPC_GPIO2->DIR |=  (0x1<<5);\
LPC_GPIO2->DIR |=  (0x1<<4);\
LPC_GPIO1->DIR |=  (0x1<<9);\
LPC_GPIO0->DIR |=  (0x1<<5);\
\
LPC_GPIO2->DATA &=  ~(0x1<<5);\
LPC_GPIO2->DATA &=  ~(0x1<<4);\
LPC_GPIO1->DATA &=  ~(0x1<<9);\
LPC_GPIO0->DATA &=  ~(0x1<<5);\
\
LPC_GPIO2->DIR |= (0x1<<7);\
LPC_GPIO0->DIR |= (0x1<<2);\
LPC_GPIO1->DIR |= (0x1<<8);\
\
LPC_GPIO2->DATA &= ~(0x1<<7);\
LPC_GPIO0->DATA &= ~(0x1<<2);\
LPC_GPIO1->DATA &= ~(0x1<<8);\
\
LPC_GPIO0->DIR |= (0x1<<4);\
LPC_GPIO2->DIR |= (0x1<<1);\
LPC_GPIO2->DIR |= (0x1<<8);\
\
LPC_GPIO0->DATA &= ~(0x1<<4);\
LPC_GPIO2->DATA &= ~(0x1<<1);\
LPC_GPIO2->DATA &= ~(0x1<<8);\
} while(0)

#define CLR_E_1()    LPC_GPIO2->DATA &= ~(0x1<<7)
#define SET_E_1()    LPC_GPIO2->DATA |=  (0x1<<7)
#define CLR_RW_1()   LPC_GPIO0->DATA &= ~(0x1<<2)
#define SET_RW_1()   LPC_GPIO0->DATA |=  (0x1<<2)
#define CLR_RS_1()   LPC_GPIO1->DATA &= ~(0x1<<8)
#define SET_RS_1()   LPC_GPIO1->DATA |=  (0x1<<8)

#define CLR_E_2()    LPC_GPIO0->DATA &= ~(0x1<<4)
#define SET_E_2()    LPC_GPIO0->DATA |=  (0x1<<4)
#define CLR_RW_2()   LPC_GPIO2->DATA &= ~(0x1<<1)
#define SET_RW_2()   LPC_GPIO2->DATA |=  (0x1<<1)
#define CLR_RS_2()   LPC_GPIO2->DATA &= ~(0x1<<8)
#define SET_RS_2()   LPC_GPIO2->DATA |=  (0x1<<8)

#define SET_D4()   LPC_GPIO2->DATA |=  (0x1<<5)
#define SET_D5()   LPC_GPIO2->DATA |=  (0x1<<4)
#define SET_D6()   LPC_GPIO1->DATA |=  (0x1<<9)
#define SET_D7()   LPC_GPIO0->DATA |=  (0x1<<5)

#define CLR_D4()   LPC_GPIO2->DATA &=  ~(0x1<<5)
#define CLR_D5()   LPC_GPIO2->DATA &=  ~(0x1<<4)
#define CLR_D6()   LPC_GPIO1->DATA &=  ~(0x1<<9)
#define CLR_D7()   LPC_GPIO0->DATA &=  ~(0x1<<5)



#define SET_DATA_HIGH(x)     do { \
                                  if(x&0x80) SET_D7(); else CLR_D7();\
                                  if(x&0x40) SET_D6(); else CLR_D6();\
                                  if(x&0x20) SET_D5(); else CLR_D5();\
                                  if(x&0x10) SET_D4(); else CLR_D4();\
                                } while(0)



#define SET_DATA   SET_DATA_HIGH

#define SET_DATA_LOW(x)     do  {\
                                  if(x&0x08) SET_D7(); else CLR_D7();\
                                  if(x&0x04) SET_D6(); else CLR_D6();\
                                  if(x&0x02) SET_D5(); else CLR_D5();\
                                  if(x&0x01) SET_D4(); else CLR_D4();\
                                } while(0)

#define WAIT_0x80()     do{  LPC_GPIO0->DATA |= (1<<5); LPC_GPIO0->DIR &= ~(1<<5);\
                             while(LPC_GPIO0->DATA & (1<<5));\
                             LPC_GPIO0->DIR |= (1<<5);\
                          } while(0)

#define delay_ms(x)    Dly100us(x*10)
#define wait_1us(x)    Dly1us(x)



void lcd_init_1(void);
void lcd_init_2(void);
void lcd_puts(int lcd, int line, char const * text);
void lcd_test_pins_1(void);
void lcd_test_pins_2(void);
#endif

